
require fs
require path
require console

copyAndFormat = (fileOrDir, target, {>project} = options) ->
  if fs.statSync(fileOrDir).isDirectory()
    if path.basename(fileOrDir) in [ "node_modules", "_requirejs" ]
      # Don't clone node_modules
      return
    fs.mkdirSync(target)
    for f in fs.readdirSync(fileOrDir)
      copyAndFormat(path.join(fileOrDir, f), path.join(target, f), options)
    return

  contents = fs.readFileSync(fileOrDir, 'utf8')
  newContents = contents.replace(/__project__/g, project)
  fs.writeFileSync(target, newContents)


this.createApp = (name) ->
  base = path.resolve(name)
  name = path.basename(name)
  if fs.existsSync(base)
    console.error("Project at #{base} exists")
    process.exit(1)

  copyAndFormat(path.join(__dirname, '../../templates/app'), base,
      project: name)
  console.log("Project #{name} created")
